﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
/*
Created by Bradley Marden as Part of the Ez Game Logic collection
Find more information at ez-gamelogic.com/ez-basebuilding
Email: bradleymarden@ez-gamelogic.com
*/
public class PlayerController : MonoBehaviour
{
    
    private Transform player;
    [SerializeField] int speed;
    private float translation;
    private float straffe;
    private Rigidbody rigidBody;
    Vector2 mouseLook;
    Vector2 smoothV;
    public float sensitivity = 0.5f;
    public float smoothing = 2.0f;
    public bool isPaused;
    [SerializeField] private bool jumping;
    public bool locked;
    [SerializeField] private float lookUpClamp = 90;
    [SerializeField] private float lookDownClamp = -90;
    private Transform child;


    private void Awake() 
    {
        player = this.transform;
        rigidBody = this.transform.GetComponent<Rigidbody>();
        child = transform.GetChild(0).transform;
    }
    private void Start() {
        Cursor.lockState = CursorLockMode.Locked;
        locked = true;
    }
    private void FixedUpdate() 
    {
        MovePlayer();
        EnableCursor();
        MoveHead();
        Jump();
    }
    private void MovePlayer()
    {
        translation = Input.GetAxis("Vertical") * speed;
        straffe = Input.GetAxis("Horizontal") * speed;
        translation *= Time.deltaTime;
        straffe *= Time.deltaTime;
        player.Translate(straffe,0,translation);
    }
    private void MoveHead()
    {
        if (isPaused == false)
        {
            var md = new Vector2(Input.GetAxisRaw("Mouse X"),Input.GetAxisRaw("Mouse Y"));
            md = Vector2.Scale(md, new Vector2(sensitivity * smoothing, sensitivity* smoothing));
            smoothV.x = Mathf.Lerp(smoothV.x, md.x, 1f/smoothing);
            smoothV.y = Mathf.Lerp(smoothV.y, md.y, 1f / smoothing);
            mouseLook+= smoothV;
            mouseLook.y = Mathf.Clamp(mouseLook.y, lookDownClamp, lookUpClamp);
            child.localRotation = Quaternion.AngleAxis(-mouseLook.y, Vector3.right);
            player.localRotation = Quaternion.AngleAxis(mouseLook.x, player.up);
        }
    }

    public void EnableCursor()
    {
        if (Input.GetKeyDown("escape"))
        {
            locked = !locked;
            //isPaused = !isPaused;
        }
        if (locked == false)
        {
            Cursor.lockState = CursorLockMode.None;
            isPaused = true;
        }
        else
        {
            Cursor.lockState = CursorLockMode.Locked;
            isPaused = false;
        }
    }
    private void Jump()
    {
        if (jumping == false)
        {
            if (Input.GetKeyDown(KeyCode.Space))
            {
                rigidBody.velocity += 4 * Vector3.up;
            }
        }
    }
    private void OnTriggerEnter(Collider other) 
    {
        jumping = false;
    }
     private void OnTriggerExit(Collider other) 
     {
        jumping = true;
     }
}
