﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
public class Slot : MonoBehaviour
{
    [SerializeField] private string itemName;
    [SerializeField] private Sprite itemIcon;
    [SerializeField] public int itemID;

    public bool hasItem;
    public int stackAmount;
    private Text text;

    private void Awake() {
        text = this.transform.GetChild(0).GetComponent<Text>();
    }
    private void Update() {
        SetText();
    }
    private void SetIcon()
    {
        GetComponent<Image>().sprite = itemIcon;
    }
    private void ClearIcon()
    {
        GetComponent<Image>().sprite = itemIcon;
    }
    private void SetText()
    {
        text.text = stackAmount.ToString();
    }

    public void SetSlotVariables(string name, Sprite icon, int id)
    {
        itemName = name;
        itemIcon = icon;
        itemID = id;
        hasItem = true;
        SetIcon();
        
        //stackAmount++;
    }
    public void ClearSlotVariables()
    {
        if (stackAmount > 1)
        {
            stackAmount--;

        }else
        {
            itemName = null;
            itemIcon = null;
            hasItem = false;
            ClearIcon();
        }
        
        
    }
}
