﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.EventSystems;

public class InventoryManager : MonoBehaviour
{
    private GameObject inventoryUI;
    private GameObject player;
    PlayerController playerController;

    

    private bool openInventoryUI;
    private bool cursorLock;

    [SerializeField] private List<GameObject> slots = new List<GameObject>();
    [SerializeField] private GameObject slotParent;

    private void Awake() 
    {
        inventoryUI = GameObject.FindGameObjectWithTag("InventoryUI");
        player = GameObject.FindGameObjectWithTag("Player");
        playerController = player.GetComponent<PlayerController>();
        slotParent = GameObject.FindGameObjectWithTag("SlotsParent");
        for (int i = 0; i < slotParent.transform.childCount; i++)
        {
            slots.Add(slotParent.transform.GetChild(i).gameObject);
        }
    }
    private void Start() 
    {
        inventoryUI.SetActive(false);
        cursorLock = playerController.locked;
    }
    private void Update() 
    {
        ControlUI();
    }

    private void ControlUI()
    {
        if (Input.GetKeyDown("tab"))
        {
            openInventoryUI =!openInventoryUI;
            inventoryUI.SetActive(openInventoryUI);
            if (openInventoryUI)
            {
                playerController.locked = false;// unlocks the cursor
                playerController.isPaused = true;//pauses the control of the camera with the mouse
            }
            else
            {
                playerController.locked = true;//locks the cursor
                playerController.isPaused = false;//unpauses the control of the camera with the mouse

            }
        }
    }
    public void SlotName()
    {
        GameObject hold = EventSystem.current.currentSelectedGameObject;
        hold.GetComponent<Slot>().ClearSlotVariables();
    }
    public void AddToSlot(GameObject item)
    {
        for (int i = 0; i < slots.Count; i++)
        {
            if (slots[i].GetComponent<Slot>().itemID == item.GetComponent<Item>().iID)
            {
                slots[i].GetComponent<Slot>().stackAmount++;
                Destroy(item);
                break;
            }
            else if (slots[i].GetComponent<Slot>().hasItem == false)
            {
                slots[i].GetComponent<Slot>().SetSlotVariables(item.GetComponent<Item>().iName, item.GetComponent<Item>().iIcon, item.GetComponent<Item>().iID);
                slots[i].GetComponent<Slot>().stackAmount = 1;
                Destroy(item);
                break;
            }
            else
            {
                Debug.Log("Inventory Full!");
            }
        }
    }




}
